local name, addon = ...
addon['name'] = name
addon['parentName'] = name
addon['inits'] = addon['inits'] or {}
addon['defaults'] = {
	['profile'] = {
		["zz_Skeletontoggle"] = false,
	}
}
addon['db'] = {}
local brokers = {}

addon['RegisterBroker'] = function(brokerName, brokerFunc,default,defaults)
	brokers[brokerName] = {
		['func'] = brokerFunc,
		['default'] = default,
		['defaults'] = defaults,
	}
end

addon['PLAYER_ENTERING_WORLD'] = function(self,event,...)
	for broker, tab in pairs(brokers) do
		if(type(tab['defaults']) == 'table') then
			addon['db']['profile'][broker] = addon['db']['profile'][broker] or tab['defaults']
		else
			addon['db']['profile'][broker] = addon['db']['profile'][broker] or {}
		end
		addon['AddConfigEntry'](addon, name,"toggle",broker.."toggle",broker,"Enable/Disable "..broker.." on next reload",1,nil,nil,nil,nil,addon['options']['args'][name])
		if(addon['db']['profile'][broker..'toggle'] or addon['db']['profile'][broker..'toggle'] == nil) then
			tab['func']()
		end
	end
	self:UnregisterEvent(event)
end

addon['ADDON_LOADED'] = function(self,event,arg1)
	if(arg1 ~= name) then return end
	addon['db'] = LibStub("AceDB-3.0"):New(name.."DB", addon['defaults'], true)
	addon['db']['profile'][name] = addon['db']['profile'][name] or {}
	addon['InitConfig'](addon, name)
	self:UnregisterEvent(event)
end

addon['RegisterFunc']({'ADDON_LOADED','PLAYER_ENTERING_WORLD'},"OnEvent", function(self, event, ...)
	if(type(addon[event]) == 'function') then
		addon[event](self, event, ...)
	end
end)
-- addon['inits'][name] = init